%%
cd C:\Users\hyong\Dropbox\papers\matrixOMT\test_cuda
mexcuda -g momt_real_mex.cu '-LC:\Program Files (x86)\Windows Kits\10\Lib\10.0.10240.0\ucrt\x64' '-IC:\Program Files (x86)\Windows Kits\10\Include\10.0.10240.0\ucrt'
%mexcuda -g momt_complex_mex.cu '-LC:\Program Files (x86)\Windows Kits\10\Lib\10.0.10240.0\ucrt\x64' '-IC:\Program Files (x86)\Windows Kits\10\Include\10.0.10240.0\ucrt'

%%
clear all;
n = 256;
ell = 3;

Lambda0 = zeros(n,n,3,3);
Lambda1 = zeros(n,n,3,3);

%Lambda0(n/2,n/2,:,:) = 1/3*eye(3);
%Lambda1(n/4,n/2,:,:) = 1/3*eye(3);


randn('state',0);
A = randn(3,3);
%A = randn(3,3) + i*randn(3,3);
A = A'*A;
A = A/trace(A);
Lambda0(n/2,n/2,:,:) = A;
A = randn(3,3);
%A = randn(3,3) + i*randn(3,3);
A = A'*A;
A = A/trace(A);
Lambda1(n/2,n/2,:,:) = A;

L = zeros(3,3, ell);
L(:,:,1) = [1,1,1;
            1,0,0;
            1,0,0;];
L(:,:,2) = diag([1,2,3]);
L(:,:,3) = [1, 0.5, 0;
            0.5, 0.8, 0;
            0, 0, 0.2];

options = MOMT_options();

options.max_iter =1000;
options.nu =1;


[d_val, U, W, Phi] = MOMT(Lambda0, Lambda1,L,.01,options);
%%
%u plotter
d = 2;
u_scalar = zeros(n,n,d);

for i=1:n
    for j=1:n
        for k = 1:d
            u_scalar(i,j,k) = trace(reshape(U(i,j,:,:,k), 3,3));
        end
    end
end

uux = zeros(32,32);
uuy = zeros(32,32);
ux = u_scalar(:,:,1);
uy = u_scalar(:,:,2);
for ii=1:32
    for jj=1:32
        for kk=1:8
            for ll=1:8
                uux(ii,jj) = uux(ii,jj) + ux(8*(ii-1)+kk,8*(jj-1)+ll);
                uuy(ii,jj) = uuy(ii,jj) + uy(8*(ii-1)+kk,8*(jj-1)+ll);
            end
        end
    end
end



hold on;
[YY,XX] = meshgrid(linspace(0,1,32),linspace(-0,1,32));
%quiver(XX,YY,m(1:256,:),m((n+1):(2*n),:), 1)
quiver(XX,YY,uux,uuy, 1,'color',[1, .3, .3])

daspect([max(daspect)*[1 1] 1])
pbaspect([1 1 1])

h=gca;
set(h,'XTick',[])
set(h,'YTick',[])

ax = gca;
ax.OuterPosition(3)=ax.OuterPosition(4);
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

%%
%Phi plotter 

phi_scalar = zeros(n,n);

for i=1:n
    for j=1:n
        phi_scalar(i,j) = trace(reshape(Phi(i,j,:,:), 3,3));
    end
end

[YY,XX] = meshgrid(linspace(-2,2,n),linspace(-2,2,n));
figure();
surf(XX,YY,phi_scalar)
shading interp
light		
lighting gouraud
xlabel('x'); ylabel('y')
title('\Phi plot')



