%%
cd C:\Users\hyong\Dropbox\papers\matrixOMT\test_cuda
mexcuda -g vomt_mex.cu '-LC:\Program Files (x86)\Windows Kits\10\Lib\10.0.10240.0\ucrt\x64' '-IC:\Program Files (x86)\Windows Kits\10\Include\10.0.10240.0\ucrt'
%%
n=256;
xx = linspace(-2,2,n);
yy = linspace(-2,2,n);
[XX,YY] = meshgrid(linspace(-2,2,n),linspace(-2,2,n));

%rho0 generator
rho0 = zeros(n,n,3);
for ii=1:n
    for jj=1:n
        if (sqrt((xx(jj)).^2+(yy(ii)).^2)<0.3)
            rho0(ii,jj,1) = 1;
            rho0(ii,jj,2) = 1;
            rho0(ii,jj,3) = 1;
        end
    end
end
rho0 = rho0 / sum(sum(sum(rho0)));


%rho1 generator
rho1 = zeros(n,n,3);
for ii=1:n
    for jj=1:n
        if (sqrt((xx(jj)-1).^2+(yy(ii)-1).^2)<0.2)
            rho1(ii,jj,1) = 1;
        end
        if (sqrt((xx(jj)+1).^2+(yy(ii)-1).^2)<0.2)
            rho1(ii,jj,2) = 1;
        end
        if (sqrt((xx(jj)-1).^2+(yy(ii)+1).^2)<0.2)
            rho1(ii,jj,3) = 1;
        end
    end
end
rho1 = rho1/sum(sum(sum(rho1)));

%%

options = VOMT_options();
options.max_iter=10000;
options.nu =1;
options.u_norm_type = 'l12 norm';
[d_val, u, w, phi]=VOMT(rho0, rho1, 1, 1, 1, 10, options);
%%

%rho1-rho0 plotter
%n=256;
[XX,YY] = meshgrid(linspace(-2,2,n),linspace(-2,2,n));

I=zeros(n,n,3);
I = I + rho0/max(max(max(rho0)));
I = I + rho1/max(max(max(rho1)));
imagesc([-2,2],[-2,2],I);
hold on;





n=256;
mmx = zeros(32,32);
mmy = zeros(32,32);
for ii=1:32
    for jj=1:32
        for kk=1:8
            for ll=1:8
                mmx(ii,jj) = mmx(ii,jj) + u(8*(ii-1)+kk,8*(jj-1)+ll,1,1);
                mmy(ii,jj) = mmy(ii,jj) + u(8*(ii-1)+kk,8*(jj-1)+ll,1,2);
            end
        end
    end
end
[XX,YY] = meshgrid(linspace(-2,2,32),linspace(-2,2,32));
%quiver(XX,YY,m(1:256,:),m((n+1):(2*n),:), 1)
quiver(XX,YY,mmy,mmx, 1,'color',[1, 0, 0])
hold on;



mmx = zeros(32,32);
mmy = zeros(32,32);
for ii=1:32
    for jj=1:32
        for kk=1:8
            for ll=1:8
                mmx(ii,jj) = mmx(ii,jj) + u(8*(ii-1)+kk,8*(jj-1)+ll,2,1);
                mmy(ii,jj) = mmy(ii,jj) + u(8*(ii-1)+kk,8*(jj-1)+ll,2,2);
            end
        end
    end
end
[XX,YY] = meshgrid(linspace(-2,2,32),linspace(-2,2,32));
%quiver(XX,YY,m(1:256,:),m((n+1):(2*n),:), 1)
quiver(XX,YY,mmy,mmx, 1,'color',[0, 1, 0])
hold on;



mmx = zeros(32,32);
mmy = zeros(32,32);
for ii=1:32
    for jj=1:32
        for kk=1:8
            for ll=1:8
                mmx(ii,jj) = mmx(ii,jj) + u(8*(ii-1)+kk,8*(jj-1)+ll,3,1);
                mmy(ii,jj) = mmy(ii,jj) + u(8*(ii-1)+kk,8*(jj-1)+ll,3,2);
            end
        end
    end
end
[XX,YY] = meshgrid(linspace(-2,2,32),linspace(-2,2,32));
%quiver(XX,YY,m(1:256,:),m((n+1):(2*n),:), 1)
quiver(XX,YY,mmy,mmx, 1,'color',[0, 0, 1])
hold on;


% n=256;
% for ii=1:32
%     for jj=1:32
%         mmx = zeros(3,1);
%         mmy = zeros(3,1);
%         for kk=1:8
%             for ll=1:8
%                 mmx = mmx + reshape(u(8*(ii-1)+kk,8*(jj-1)+ll,:,1),3,1);
%                 mmy = mmy + reshape(u(8*(ii-1)+kk,8*(jj-1)+ll,:,2),3,1);
%             end
%         end
%         color = sqrt(mmx.^2+mmy.^2);
%         if max(color)==0
%             color = [0;0;0];
%         else
%             color = color./max(color);
%         end
%         disp([sum(mmy),sum(mmx)])
%         quiver(XX(ii),YY(jj),sum(mmy),sum(mmx), 1,'color',[1 1 1])
%         hold on;
%     end
% end



daspect([max(daspect)*[1 1] 1])
pbaspect([1 1 1])

h=gca;
set(h,'XTick',[])
set(h,'YTick',[])

ax = gca;
ax.OuterPosition(3)=ax.OuterPosition(4);
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];