function [d_val, m, phi, tilde_rho0, tilde_rho1]=partial_wass(rho0, rho1,gamma,options)
%later write padding functionality
%for now, n has to be a power of 2

n = size(rho0);
n = n(1);

if ~( isreal(rho0) && isreal(rho1) )
    error('Input must be real');
end

if ~( isequal(size(rho0),[n,n]) && isequal(size(rho1),[n,n]) && isequal(size(rho0),size(rho1))  )
    error('rho0 or rho1 input size wrong');
end

if ~( (min(min(rho0))>=0) && (min(min(rho1))>=0) )
    error('rho0 and rho1 must be positive');
end





use_smart_interval = true;

tau = options.tau;
if (n==32)
    if tau==0
        tau = 0.1;
    end
    max_iter = .5e5;
elseif (n==64)
    if tau==0
        tau = 0.1;
    end
    max_iter = 1e5;
elseif (n==128)
    if tau==0
        tau = 0.1;
    end
    max_iter = 2.5e5;
elseif (n==256)
    if tau==0
        tau = 0.1;
    end
    max_iter = 5e5;
else
    error('n has to be a power of 2 and bigger than 32');
end


mu = 1/(32*(n-1)^2*tau);
nu = 1/(4*tau);

%by default use l2 norm
norm_type = 2;

if exist('options','var')
    if options.max_iter ~= 0
        max_iter = options.max_iter;
    end
    if strcmp(options.norm_type, 'l1 norm')
        norm_type = 1;
    elseif strcmp(options.norm_type,'l2 norm')
        norm_type = 2;
    else
        error('incorrect norm type');
    end
    use_smart_interval = options.use_smart_interval;
end

if ( abs(sum(sum(rho0)) - sum(sum(rho1))) < 0.01*(sum(sum(rho0))+sum(sum(rho1)))/2 && ( abs(sum(sum(rho1))-gamma) < 0.01*gamma) )
    disp('somt chosen');
    [d_val, m, phi]=somt_mex(rho0, rho1, mu, tau, max_iter, norm_type);
    tilde_rho0 = rho0;
    tilde_rho1 = rho1;
    return
end

if ( (sum(sum(rho0)) <= sum(sum(rho1))) && ( abs(sum(sum(rho0)) - gamma) < 0.01*gamma ) )
    disp('unbalanced chosen');
    [d_val, m, phi, tilde_rho1]= unbalanced_mex(rho0, rho1, gamma, mu, nu, tau, max_iter, use_smart_interval, norm_type);
    tilde_rho0 = rho0;
    return
end
if ( (sum(sum(rho1)) <= sum(sum(rho0))) && ( abs(sum(sum(rho1)) - gamma) < 0.01*gamma ) )
    disp('unbalanced flip chosen');
    [d_val, m, phi, tilde_rho0]= unbalanced_mex(rho1, rho0, gamma, mu, nu, tau, max_iter, use_smart_interval, norm_type);
    tilde_rho1 = rho1;
    m = -m;
    phi = -phi;
    return
end

disp('partial chosen');
if (nargout==3)
    [d_val, m, phi, ~, ~]= partial_mex(rho0, rho1, gamma, mu, nu, tau, max_iter, use_smart_interval, norm_type);
else
    [d_val, m, phi, tilde_rho0, tilde_rho1]= partial_mex(rho0, rho1, gamma, mu, nu, tau, max_iter, use_smart_interval, norm_type);
end


end